Bullet Collision Detection & Physics Library: btConvexInternalAabbCachingShape Class Reference

Bullet Collision Detection & Physics Library

Public Member Functions | Protected Member Functions | Private Attributes | List of all members
btConvexInternalAabbCachingShape Class Reference

btConvexInternalAabbCachingShape adds local aabb caching for convex shapes, to avoid expensive bounding box calculations More...

`#include <btConvexInternalShape.h>`

Inheritance diagram for btConvexInternalAabbCachingShape:
[legend]
Collaboration diagram for btConvexInternalAabbCachingShape:
[legend]

## Public Member Functions
virtual void | setLocalScaling (const btVector3 &scaling)
virtual void | getAabb (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
| getAabb's default implementation is brute force, expected derived classes to implement a fast dedicated version More...
void | recalcLocalAabb ()
Public Member Functions inherited from btConvexInternalShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
virtual | ~btConvexInternalShape ()
virtual btVector3 | localGetSupportingVertex (const btVector3 &vec) const
const btVector3 & | getImplicitShapeDimensions () const
void | setImplicitShapeDimensions (const btVector3 &dimensions)
| warning: use setImplicitShapeDimensions with care changing a collision shape while the body is in the world is not recommended, it is best to remove the body from the world, then make the change, and re-add it alternatively flush the contact points, see documentation for 'cleanProxyFromPairs' More...
void | setSafeMargin (btScalar minDimension, btScalar defaultMarginMultiplier=0.1f)
void | setSafeMargin (const btVector3 &halfExtents, btScalar defaultMarginMultiplier=0.1f)
virtual void | getAabbSlow (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
virtual const btVector3 & | getLocalScaling () const
const btVector3 & | getLocalScalingNV () const
virtual void | setMargin (btScalar margin)
virtual btScalar | getMargin () const
btScalar | getMarginNV () const
virtual int | getNumPreferredPenetrationDirections () const
virtual void | getPreferredPenetrationDirection (int index, btVector3 &penetrationVector) const
virtual int | calculateSerializeBufferSize () const
virtual const char * | serialize (void *dataBuffer, btSerializer *serializer) const
| fills the dataBuffer and returns the struct name (and 0 on failure) More...
Public Member Functions inherited from btConvexShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btConvexShape ()
| not supported on IBM SDK, until we fix the alignment of btVector3 More...
virtual | ~btConvexShape ()
virtual btVector3 | localGetSupportingVertexWithoutMargin (const btVector3 &vec) const =0
btVector3 | localGetSupportVertexWithoutMarginNonVirtual (const btVector3 &vec) const
btVector3 | localGetSupportVertexNonVirtual (const btVector3 &vec) const
btScalar | getMarginNonVirtual () const
void | getAabbNonVirtual (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
virtual void | project (const btTransform &trans, const btVector3 &dir, btScalar &minProj, btScalar &maxProj, btVector3 &witnesPtMin, btVector3 &witnesPtMax) const
virtual void | batchedUnitVectorGetSupportingVertexWithoutMargin (const btVector3 *vectors, btVector3 *supportVerticesOut, int numVectors) const =0
Public Member Functions inherited from btCollisionShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btCollisionShape ()
virtual | ~btCollisionShape ()
virtual void | getBoundingSphere (btVector3 &center, btScalar &radius) const
virtual btScalar | getAngularMotionDisc () const
| getAngularMotionDisc returns the maximum radius needed for Conservative Advancement to handle time-of-impact with rotations. More...
virtual btScalar | getContactBreakingThreshold (btScalar defaultContactThresholdFactor) const
void | calculateTemporalAabb (const btTransform &curTrans, const btVector3 &linvel, const btVector3 &angvel, btScalar timeStep, btVector3 &temporalAabbMin, btVector3 &temporalAabbMax) const
| calculateTemporalAabb calculates the enclosing aabb for the moving object over interval [0..timeStep) result is conservative More...
bool | isPolyhedral () const
bool | isConvex2d () const
bool | isConvex () const
bool | isNonMoving () const
bool | isConcave () const
bool | isCompound () const
bool | isSoftBody () const
bool | isInfinite () const
| isInfinite is used to catch simulation error (aabb check) More...
virtual void | calculateLocalInertia (btScalar mass, btVector3 &inertia) const =0
virtual const char * | getName () const =0
int | getShapeType () const
virtual btVector3 | getAnisotropicRollingFrictionDirection () const
| the getAnisotropicRollingFrictionDirection can be used in combination with setAnisotropicFriction See Bullet/Demos/RollingFrictionDemo for an example More...
void | setUserPointer (void *userPtr)
| optional user data pointer More...
void * | getUserPointer () const
void | setUserIndex (int index)
int | getUserIndex () const
virtual void | serializeSingleShape (btSerializer *serializer) const

## Protected Member Functions
| btConvexInternalAabbCachingShape ()
void | setCachedLocalAabb (const btVector3 &aabbMin, const btVector3 &aabbMax)
void | getCachedLocalAabb (btVector3 &aabbMin, btVector3 &aabbMax) const
void | getNonvirtualAabb (const btTransform &trans, btVector3 &aabbMin, btVector3 &aabbMax, btScalar margin) const
Protected Member Functions inherited from btConvexInternalShape
| btConvexInternalShape ()

## Private Attributes
btVector3 | m_localAabbMin
btVector3 | m_localAabbMax
bool | m_isLocalAabbValid

## Additional Inherited Members
Protected Attributes inherited from btConvexInternalShape
btVector3 | m_localScaling
btVector3 | m_implicitShapeDimensions
btScalar | m_collisionMargin
btScalar | m_padding
Protected Attributes inherited from btCollisionShape
int | m_shapeType
void * | m_userPointer
int | m_userIndex

## Detailed Description

btConvexInternalAabbCachingShape adds local aabb caching for convex shapes, to avoid expensive bounding box calculations

Definition at line 182 of file btConvexInternalShape.h.

## Constructor & Destructor Documentation

## § btConvexInternalAabbCachingShape()

btConvexInternalAabbCachingShape::btConvexInternalAabbCachingShape | ( |  | ) |
| protected

Definition at line 84 of file btConvexInternalShape.cpp.

## Member Function Documentation

## § getAabb()

void btConvexInternalAabbCachingShape::getAabb | ( | const btTransform & | t,
|  | btVector3 & | aabbMin,
|  | btVector3 & | aabbMax
| ) |  | const
| virtual

getAabb's default implementation is brute force, expected derived classes to implement a fast dedicated version

Reimplemented from btConvexInternalShape.

Definition at line 93 of file btConvexInternalShape.cpp.

## § getCachedLocalAabb()

void btConvexInternalAabbCachingShape::getCachedLocalAabb | ( | btVector3 & | aabbMin,
|  | btVector3 & | aabbMax
| ) |  | const
| inlineprotected

Definition at line 199 of file btConvexInternalShape.h.

## § getNonvirtualAabb()

void btConvexInternalAabbCachingShape::getNonvirtualAabb | ( | const btTransform & | trans,
|  | btVector3 & | aabbMin,
|  | btVector3 & | aabbMax,
|  | btScalar | margin
| ) |  | const
| inlineprotected

Definition at line 206 of file btConvexInternalShape.h.

## § recalcLocalAabb()

void btConvexInternalAabbCachingShape::recalcLocalAabb | ( |  | ) |

Definition at line 105 of file btConvexInternalShape.cpp.

## § setCachedLocalAabb()

void btConvexInternalAabbCachingShape::setCachedLocalAabb | ( | const btVector3 & | aabbMin,
|  | const btVector3 & | aabbMax
| ) |  |
| inlineprotected

Definition at line 192 of file btConvexInternalShape.h.

## § setLocalScaling()

void btConvexInternalAabbCachingShape::setLocalScaling | ( | const btVector3 & | scaling | ) |
| virtual

Reimplemented from btConvexInternalShape.

Definition at line 98 of file btConvexInternalShape.cpp.

## Member Data Documentation

## § m_isLocalAabbValid

bool btConvexInternalAabbCachingShape::m_isLocalAabbValid
| private

Definition at line 186 of file btConvexInternalShape.h.

## § m_localAabbMax

btVector3 btConvexInternalAabbCachingShape::m_localAabbMax
| private

Definition at line 185 of file btConvexInternalShape.h.

## § m_localAabbMin

btVector3 btConvexInternalAabbCachingShape::m_localAabbMin
| private

Definition at line 184 of file btConvexInternalShape.h.

The documentation for this class was generated from the following files:

- btConvexInternalShape.h
- btConvexInternalShape.cpp